//------------------------------------------------------------------------------
process Caja_De_Texto(int iX, int iAncho, int iY, int iAlto, string sTexto, int iFuente,int iAncho_Barra)

/*
Proceso que dibuja una barra caja y una barra deslizante si es necesario.

iX: 	Coordenada X.
iAncho:	Ancho de la caja. 0-Por defecto toda la pantalla.
iY:		Coordenada Y.
iAlto:	Alto de la caja. 0-Por defecto toda la pantalla.
sTexto: Texto a mostrar.
iFuente:      Fuente del texto. 0 por defecto la de sistema.
iAncho_Barra: Ancho de la barra deslizante.

dColor_Boton_Barra: 	Color del boton que se desliza sobre la barra. 0-Gris Oscuro por defecto.
iValor_Maximo:	n de lneas de texto.
iValor_Inicial:	1 linea a mostrar.
iValor:			Lnea por la que vamos.
*/



private
	iIde[100]=0; // Contiene las lineas del write_var.
	byte bContador=0;  // Contador de usos mltiples.
	int iTabla_Lineas[10000]=0; //Tabla de comienzo de las lneas de texto.
	int iCantidad_Lineas=100; //Cantidad de lneas en el texto.
	int iSeparacion_Lineas=1;
	int iLineas_Caja=17;
	int iLinea=0;
	int iAlto_Linea=0; //Alto mximo de una lnea;
	string sPantalla[30];
	int iPrincipio_Pantalla=0;
	int iFinal_Pantalla=0;
	int iValor_Anterior; // Valor a comparar con el de la barra.
	MarcoVentana iIdeMarcoVentana=0;
	Barra_Deslizante iBarra=0;
	Boton iBoton=0;
	string sOk="OK";
end

begin
	signal(ALL_PROCESS,s_freeze);
	iDrawingZZ=iDrawingZZ-200;
	iTextZ=iTextZ-240;
	drawing_z(iDrawingZZ);  // Coordenadas de dibujo muy altas para asegurarnos que se ve el botn.
	Text_Z=iTextz;
	// Inicializando varables por defecto.
	if (iAncho==0)
		iAncho=200;
	end
	if (iAlto==0)
		iAlto=300;
	end
	iIdeMarcoVentana=MarcoVentana(iX+2, iY+2, iAncho-5, iAlto-5, 2, "");
	//Dibujo la caja.
	//Calculo cantidad de lneas en el texto y me hago una tabla.
	sTexto=regex_replace(chr(9)," ",sTexto);
	iCantidad_Lineas=Calcula_Lineas(sTexto, iFuente, iAncho-iAncho_Barra-20, &iTabla_Lineas);
	iAlto_Linea=text_height(iFuente,sTexto);
	iLineas_Caja=((iAlto-10)/(iAlto_Linea+iSeparacion_Lineas))-1;
	// Dibujo la tabla.
	iBarra=Barra_Deslizante(iX+iAncho-iAncho_Barra-3,iAncho_Barra,iY+4,iAlto-7-17,0,0,0,0,0,
		iCantidad_Lineas-iLineas_Caja,0,iDrawingZZ-40,iTextZ);
	iBarra.iSalto=iLineas_Caja;
	iBoton=boton(313,0,&sOk,1,iFuenteBlack,4,rgb(212,208,200),0,2,0, iDrawingZZ-40, iTextZ);
	iBoton.iX=4;
	iBoton.iY=220;
	iBoton.bRepintar=1;
	set_text_color(0);
	// Inicializando write_var.
	ilinea=0;
	while ((iLinea<iLineas_Caja)and(iFinal_Pantalla<=iCantidad_Lineas))
		if(sTexto[iTabla_Lineas[iFinal_Pantalla+1]-2]==13)
			sPantalla[iLinea]=substr(sTexto,iTabla_Lineas[iFinal_Pantalla],iTabla_Lineas[iFinal_Pantalla+1]-iTabla_Lineas[iFinal_Pantalla]-2);
		else
			if(sTexto[iTabla_Lineas[iFinal_Pantalla+1]-1]==10)
				sPantalla[iLinea]=substr(sTexto,iTabla_Lineas[iFinal_Pantalla],iTabla_Lineas[iFinal_Pantalla+1]-iTabla_Lineas[iFinal_Pantalla]-1);
			else
				sPantalla[iLinea]=substr(sTexto,iTabla_Lineas[iFinal_Pantalla],iTabla_Lineas[iFinal_Pantalla+1]-iTabla_Lineas[iFinal_Pantalla]);
			end
		end
		iIde[iLinea]=write_var(iFuente,iX+4,iLinea*(iAlto_Linea+iSeparacion_Lineas)+iY+8,0,sPantalla[iLinea]);
		iLinea++;
		iFinal_Pantalla++;
	end
	Pinta_Pantalla(iX+3, iY, 0, sTexto, 
		 &iTabla_Lineas, iAlto_Linea, iSeparacion_Lineas, iFuente, iLineas_Caja, iCantidad_Lineas, iBarra
		 ,&iPrincipio_Pantalla, &iFinal_Pantalla, &sPantalla);
	iValor_Anterior=iBarra.iValor;
	 while (!iBoton.bPulsado and bAbortar==0)
		if(iValor_Anterior!=iBarra.iValor)
			iValor_Anterior=iBarra.iValor;
			Pinta_Pantalla(iX+3, iY, -1, sTexto, 
				 &iTabla_Lineas, iAlto_Linea, iSeparacion_Lineas, iFuente, iLineas_Caja, iCantidad_Lineas, iBarra
				 ,&iPrincipio_Pantalla, &iFinal_Pantalla, &sPantalla);
		end

		if (KeyPausa(_JKEY_down)) 
			if (iBarra.iValor<iCantidad_Lineas-iLineas_Caja)
				iBarra.iValor++;
				iValor_Anterior=iBarra.iValor;
				iBarra.bRepintar=1;
				Pinta_Pantalla(iX+3, iY, _down, sTexto, 
					 &iTabla_Lineas, iAlto_Linea, iSeparacion_Lineas, iFuente, iLineas_Caja, iCantidad_Lineas,
					 iBarra,&iPrincipio_Pantalla, &iFinal_Pantalla, &sPantalla);
			end
		end
		if (KeyPausa(_JKEY_UP)) 
			if (iBarra.iValor>0)
				iBarra.iValor--;
				iValor_Anterior=iBarra.iValor;
				iBarra.bRepintar=1;
				Pinta_Pantalla(iX+3, iY, _up, sTexto, 
					 &iTabla_Lineas, iAlto_Linea, iSeparacion_Lineas, iFuente, iLineas_Caja, iCantidad_Lineas, iBarra
					 ,&iPrincipio_Pantalla, &iFinal_Pantalla, &sPantalla);
			end
		end
		if (KeyPausa(_JKEY_LEFT))
			iBarra.iValor=iBarra.iValor-iLineas_Caja;
			if (iBarra.iValor<0)
				iBarra.iValor=0;
			end
			iValor_Anterior=iBarra.iValor;
			iBarra.bRepintar=1;
			Pinta_Pantalla(iX+3, iY, -1, sTexto, 
				 &iTabla_Lineas, iAlto_Linea, iSeparacion_Lineas, iFuente, iLineas_Caja, iCantidad_Lineas, iBarra
				 ,&iPrincipio_Pantalla, &iFinal_Pantalla, &sPantalla);
		end
		if (KeyPausa(_JKEY_right))
			iBarra.iValor=iBarra.iValor+iLineas_Caja;
			if (iBarra.iValor>iCantidad_Lineas-iLineas_Caja)
				iBarra.iValor=iCantidad_Lineas-iLineas_Caja;
			end
			iValor_Anterior=iBarra.iValor;
			iBarra.bRepintar=1;
			Pinta_Pantalla(iX+3, iY, -1, sTexto, 
				 &iTabla_Lineas, iAlto_Linea, iSeparacion_Lineas, iFuente, iLineas_Caja, iCantidad_Lineas, iBarra
				 ,&iPrincipio_Pantalla, &iFinal_Pantalla, &sPantalla);
		end
		frame;
	end
	while (iBoton.bPulsado);
		frame;
	end
	OnExit

		if (exists(iIdeMarcoVentana))
			signal(iIdeMarcoVentana,s_kill_tree);
		end
		frame;
		if (exists(iBoton))
			signal(iBoton,s_Kill_tree);
		end
		frame;
		if (exists(iBarra))
			signal(iBarra,s_Kill_tree);
		end
		frame;
		bContador=0;
		while (bContador<iLineas_Caja and bContador<=iCantidad_Lineas)
			delete_text(iIde[bContador]);
			bContador++;
		end
		signal(ALL_PROCESS,s_wakeup);
		frame;

end
//------------------------------------------------------------------------------
function Calcula_Lineas(string sTexto, int iFuente, int iAncho, pointer iTabla_Lineas)
// Formatea la variable sTexto y calcula el n de lineas.

private 
	int iLongitud; //Longitud sTexto.
	int iInicio_Linea=0;
	int iFinal_Linea=1;
	int iCantidad_Lineas=0;
	VentanaProgreso Progreso;
	int dAntiguoValorOrigen=0;
	int iContador=0;
	int iContador2=0;
end

begin
	bAbortar=0;
	dValorOrigen=1;
	Progreso=VentanaProgreso(0,0,0,0,0,iDrawingZZ,iTextZ);
	Progreso.bRepintar=1;
	frame;
	iLongitud=len(sTexto);
	//Relleno tabla de lineas.
	while (iFinal_Linea<=iLongitud and bAbortar==0)
		if((sTexto[iFinal_Linea]==13)or
			  (text_width(iFuente,substr(sTexto,iInicio_Linea,iFinal_Linea-iInicio_Linea+1))>iAncho)or
			  (iFinal_Linea==iLongitud))
			if(sTexto[iFinal_Linea+1]==10)
				iFinal_Linea++;
			end
			iTabla_Lineas[iCantidad_Lineas]=iInicio_Linea;
			iInicio_Linea=iFinal_Linea+1;
			iCantidad_Lineas++;
			dValorOrigen=(((iFinal_Linea)*100)/(iLongitud));
			if(iLongitud>20000 and dAntiguoValorOrigen!=dValorOrigen and iContador>100)
				dAntiguoValorOrigen=dValorOrigen+1;
				iContador=0;
				frame;
			end
			if(iLongitud>100000 and iContador2>10)
				frame;
				iContador2=0;
			end
			iContador++;
			iContador2++;
		end
		iFinal_Linea++;
	end
	dValorOrigen=99;
	frame;
	iTabla_Lineas[iCantidad_Lineas]=iInicio_Linea;
	if (exists(Progreso))
		signal(Progreso,s_Kill_tree);
	end
	return iCantidad_Lineas;
end
//------------------------------------------------------------------------------
function Pinta_Pantalla(int iX, int iY, int iDireccion, string sTexto, 
		 int pointer iTabla_Lineas, int iAlto_Linea, int iSeparacion_Lineas, int iFuente, int iLineas_Caja,
		 int iCantidad_Lineas, int iBarra, int pointer iPincipio_Pantalla, int pointer iFinal_Pantalla,
		 string pointer psPantalla)
/*
Funcin que repinta el texto en la caja.
0:	Pinta inicialmente,
_down:	mueve una lnea hacia abajo.
_up:	mueve una lnea hacia arriba.
_left:	mueve una pgina hacia arriba.
_right:	mueve una pgina hacia abajo.
*/

private
	int iContador=1;
	int iLinea=0; //Lnea por la que voy escribiendo.
	int iLongitud; //Longitud del sTexto;
end

begin
	iLongitud=len(sTexto);
	switch (iDireccion)
		case 0: // Inicializa.
			[iPincipio_Pantalla]=0;
			[iFinal_Pantalla]=0;
			iContador=0;
			while (iContador<=iLineas_Caja)
				psPantalla[iContador]="";
				iContador++;
			end
			ilinea=0;
			while ((iLinea<iLineas_Caja)and([iFinal_Pantalla]<=iCantidad_Lineas))
				if(sTexto[iTabla_Lineas[[iFinal_Pantalla]+1]-2]==13)
					psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iFinal_Pantalla]],iTabla_Lineas[[iFinal_Pantalla]+1]-iTabla_Lineas[[iFinal_Pantalla]]-2);
				else
					if(sTexto[iTabla_Lineas[[iFinal_Pantalla]+1]-1]==10)
						psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iFinal_Pantalla]],iTabla_Lineas[[iFinal_Pantalla]+1]-iTabla_Lineas[[iFinal_Pantalla]]-1);
					else
						psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iFinal_Pantalla]],iTabla_Lineas[[iFinal_Pantalla]+1]-iTabla_Lineas[[iFinal_Pantalla]]);
					end
				end
				//write_var(iFuente,iX+4,iLinea*(iAlto_Linea+iSeparacion_Lineas)+iY+8,0,psPantalla[iLinea]);
				iLinea++;
				[iFinal_Pantalla]++;
			end
			return;	
		end

		case -1: //Repinta dependiendo de _Barra.iValor.
			[iFinal_Pantalla]=iBarra.iValor;
			iLinea=0;
			while ((iLinea<iLineas_Caja)and([iFinal_Pantalla]<=iCantidad_Lineas))
				if(sTexto[iTabla_Lineas[[iFinal_Pantalla]+1]-2]==13)
					psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iFinal_Pantalla]],iTabla_Lineas[[iFinal_Pantalla]+1]-iTabla_Lineas[[iFinal_Pantalla]]-2);
				else
					if(sTexto[iTabla_Lineas[[iFinal_Pantalla]+1]-1]==10)
						psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iFinal_Pantalla]],iTabla_Lineas[[iFinal_Pantalla]+1]-iTabla_Lineas[[iFinal_Pantalla]]-1);
					else
						psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iFinal_Pantalla]],iTabla_Lineas[[iFinal_Pantalla]+1]-iTabla_Lineas[[iFinal_Pantalla]]);
					end
				end
				iLinea++;
				[iFinal_Pantalla]++;
			end
			[iPincipio_Pantalla]=[iFinal_Pantalla]-iLineas_Caja-1;
			return;	
		end

		case _down: // Abajo **************************
			iLinea=0;
			if  ([iFinal_Pantalla]<iCantidad_Lineas)
				[iPincipio_Pantalla]++;
				while (iLinea<iLineas_Caja)
					psPantalla[iLinea]=psPantalla[iLinea+1];
					iLinea++;
				end
				iLinea--;
				psPantalla[iLinea]="";
				if(sTexto[iTabla_Lineas[[iFinal_Pantalla]+1]-2]==13)
					psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iFinal_Pantalla]],iTabla_Lineas[[iFinal_Pantalla]+1]-iTabla_Lineas[[iFinal_Pantalla]]-2);
				else
					psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iFinal_Pantalla]],iTabla_Lineas[[iFinal_Pantalla]+1]-iTabla_Lineas[[iFinal_Pantalla]]-1);
				end
				[iFinal_Pantalla]++;
			end
			return;	
		end	
			
		case _up: // Arriba *************************************
			if ([iPincipio_Pantalla]>0)
				iLinea=iLineas_Caja;
				while (iLinea>0)
					psPantalla[iLinea]=psPantalla[iLinea-1];
					iLinea--;
				end
				psPantalla[iLinea]="";
				[iPincipio_Pantalla]--;
				[iFinal_Pantalla]--;
				if(sTexto[iTabla_Lineas[[iPincipio_Pantalla]+1]-2]==13)
					psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iPincipio_Pantalla]],iTabla_Lineas[[iPincipio_Pantalla]+1]-iTabla_Lineas[[iPincipio_Pantalla]]-2);
				else
					psPantalla[iLinea]=substr(sTexto,iTabla_Lineas[[iPincipio_Pantalla]],iTabla_Lineas[[iPincipio_Pantalla]+1]-iTabla_Lineas[[iPincipio_Pantalla]]-1);
				end
			end	
			return;	
		end	
	end
	
	
end		
//------------------------------------------------------------------------------
